## bpp-utils-1.5.0.tar.gz

=== CMakeLists.txt ===
# CMake script for Bio++ Utils
# Author: Sylvain Gaillard and Julien Dutheil
# Created: 17/08/2009

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(bpp-utils CXX)
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow")
IF(NOT NO_VIRTUAL_COV)
  SET(NO_VIRTUAL_COV FALSE CACHE BOOL
      "Disable covariant return type with virtual inheritance, for compilers that do not support it."
      FORCE)
ENDIF(NOT NO_VIRTUAL_COV)

IF(NO_VIRTUAL_COV)
  MESSAGE("-- Covariant return with virtual inheritance disabled.")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_VIRTUAL_COV=1")
ENDIF(NO_VIRTUAL_COV)

# Libtool-like version number
# CURRENT:REVISION:AGE => file.so.(C-A).A.R
# current:  The most recent interface number that this library implements.
# revision: The implementation number of the current interface.
# age:      The difference between the newest and oldest interfaces that this
#           library implements.
# In other words, the library implements all the interface numbers in the
# range from number current - age to current.
SET(BPPUTILS_VERSION_CURRENT "7")
SET(BPPUTILS_VERSION_REVISION "0")
SET(BPPUTILS_VERSION_AGE "0")

# Effective version number computation
MATH(EXPR BPPUTILS_VERSION_MAJOR "${BPPUTILS_VERSION_CURRENT} - ${BPPUTILS_VERSION_AGE}")
SET(BPPUTILS_VERSION_MINOR ${BPPUTILS_VERSION_AGE})
SET(BPPUTILS_VERSION_PATCH ${BPPUTILS_VERSION_REVISION})
SET(BPPUTILS_VERSION "${BPPUTILS_VERSION_MAJOR}.${BPPUTILS_VERSION_MINOR}.${BPPUTILS_VERSION_PATCH}")

# Subdirectories
ADD_SUBDIRECTORY(Utils)

# Doxygen
FIND_PACKAGE(Doxygen)
IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET (apidoc ${DOXYGEN_EXECUTABLE} Doxyfile)
ENDIF (DOXYGEN_FOUND)

# Packager
SET(CPACK_PACKAGE_NAME "libbpp-utils")
SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
SET(CPACK_PACKAGE_VERSION "1.5.0")
SET(CPACK_PACKAGE_VERSION_MAJOR "1")
SET(CPACK_PACKAGE_VERSION_MINOR "5")
SET(CPACK_PACKAGE_VERSION_PATCH "0")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Utils library")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.cmake"
 "/CVS/"
 ".*\\\\.gz"
 ".*\\\\.deb"
 ".*\\\\.rpm"
 "\\\\..*\\\\.swp"
 "Utils/\\\\..*"
 "Utils/libbpp*"
 "debian/libbpp*"
 "debian/tmp"
 "html"
 "Utils.tag"
 ${CPACK_SOURCE_IGNORE_FILES}
)
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF (UNIX)
#This creates deb packages:
ADD_CUSTOM_TARGET(deb fakeroot debian/rules binary)
ADD_DEPENDENCIES(deb dist)

#This creates rpm packages:
ADD_CUSTOM_TARGET(rpm rpmbuild -ta ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(rpm dist)

ENDIF()

=== Utils/CMakeLists.txt ===
# CMake script for Bio++ Utils
# Author: Sylvain Gaillard
# Created: 17/08/2009

# File list
set(CPP_FILES
  ApplicationTools.cpp
  AttributesTools.cpp
  BppApplication.cpp
  ColorTools.cpp
  DvipsColorSet.cpp
  Exceptions.cpp
  FileTools.cpp
  GraphicDevice.cpp
  KeyvalTools.cpp
  MolscriptColorSet.cpp
  NestedStringTokenizer.cpp
  PGFGraphicDevice.cpp
  RColorSet.cpp
  SVGGraphicDevice.cpp
  StringTokenizer.cpp
  TextTools.cpp
  XFigGraphicDevice.cpp
  BppString.cpp
  Font.cpp
  XFigLaTeXFontManager.cpp
  XFigPostscriptFontManager.cpp
  )

set(H_FILES
  AbstractGraphicDevice.h
  ApplicationTools.h
  AttributesTools.h
  BppApplication.h
  BppString.h
  BppVector.h
  OutputStream.h
  Clonable.h
  ColorManager.h
  ColorSet.h
  ColorTools.h
  DefaultColorSet.h
  DvipsColorSet.h
  Exceptions.h
  exceptions
  FileTools.h
  Font.h
  FontManager.h
  XFigLaTeXFontManager.h
  XFigPostscriptFontManager.h
  GraphicDevice.h
  graphics
  IOFormat.h
  KeyvalTools.h
  MapTools.h
  MolscriptColorSet.h
  NestedStringTokenizer.h
  Number.h
  PGFGraphicDevice.h
  Point2D.h
  Point2DTools.h
  RColorSet.h
  RGBColor.h
  SVGGraphicDevice.h
  StringTokenizer.h
  TextTools.h
  XFigGraphicDevice.h
)

# Build the static lib
add_library(bpputils-static STATIC ${CPP_FILES})
set_target_properties(bpputils-static
  PROPERTIES OUTPUT_NAME bpp-utils
  CLEAN_DIRECT_OUTPUT 1
  )

# Build the shared lib
add_library(bpputils-shared SHARED ${CPP_FILES})
set_target_properties(bpputils-shared
  PROPERTIES OUTPUT_NAME bpp-utils
  CLEAN_DIRECT_OUTPUT 1
  VERSION ${BPPUTILS_VERSION}
  SOVERSION ${BPPUTILS_VERSION_MAJOR}
  )

# Install libs
install(TARGETS bpputils-static bpputils-shared DESTINATION lib)

# Install headers
install(FILES ${H_FILES} DESTINATION include/Utils)

=== debian/changelog ===
libbpp-utils (1.5.0) unstable; urgency=low

  * Update for version 1.9 of Bio++.
  * Several bug fixed, compilation with -Weffc++
  * Improved graphic classes

 -- Julien Dutheil <jdutheil@birc.au.dk>  Wed, 24 Mar 2010 14:20:45 +0100

libbpp-utils (1.4.0) unstable; urgency=low

  * Update for version 1.8 of Bio++.
  * New kevval syntax for parsing parameters.

 -- Julien Dutheil <jdutheil@birc.au.dk>  Wed, 10 Jun 2009 11:28:58 +0100

libbpp-utils (1.3.1) unstable; urgency=low

  * Update for version 1.7 of Bio++.

 -- Julien Dutheil <jdutheil@birc.au.dk>  Thu, 11 Dec 2008 12:21:37 +0100

libbpp-utils (1.3.0) unstable; urgency=low

  * Initial Release.

 -- Julien Dutheil <jdutheil@birc.au.dk>  Mon, 21 Jul 2008 15:17:26 +0200

=== debian/control ===
Source: libbpp-utils
Section: libs
Priority: optional
Maintainer: Julien Dutheil <julien.dutheil@univ-montp2.fr>
Build-Depends: debhelper (>= 5), cmake (>= 2.6)
Standards-Version: 3.7.2

Package: libbpp-utils-dev
Section: libdevel
Architecture: any
Depends: libbpp-utils (= ${source:Version})
Description: The Bio++ Utils library development files.
 Contains the Bio++ core classes and tools.

Package: libbpp-utils
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Bio++ Utils library.
 Contains the Bio++ core classes and tools.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# 24/01/10 Modification for use with CMake by Julien Dutheil.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# shared library versions
version=`ls Utils/.libs/lib*.so.* | \
 awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
major=`ls Utils/.libs/lib*.so.* | \
 awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

configure:
	cmake -DCMAKE_INSTALL_PREFIX=/usr .

config.status: configure
	dh_testdir

build: build-stamp
build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	#have to do that, otherwise nothing is installed!
	cp -r $(CURDIR)/debian/tmp/usr/lib/lib*.so* $(CURDIR)/debian/libbpp-utils/usr/lib
	cp -r $(CURDIR)/debian/tmp/usr/lib/lib*.*a $(CURDIR)/debian/libbpp-utils-dev/usr/lib
	cp -r $(CURDIR)/debian/tmp/usr/include/* $(CURDIR)/debian/libbpp-utils-dev/usr/include
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
